Understanding the alerting.edgelq.com service APIv1, in proto package ntt.alerting.v1.

Service alerting.edgelq.com in version v1, proto package ntt.alerting.v1

Here is the list of resources supported in Alerting service APIv1:

Alert Resource

Alert describes an abnormal situation indicated by TimeSeries or Logs. Alert is always associated with a single resource type, as indicated in Policy object. It contains relevant information: TimeSeries/Logs values that caused the issue, starting time, ending time, if alert stopped, current handling state (by both operator and AI agent). Each Alert belongs to a single TsCondition/LogCondition resource, and is always associated with some unique TsEntry - they share alerting resource reference. Relationship Alert <-> TsEntry is N <-> 1 Relationship Alert <-> TsCondition/LogCondition is N <-> 1

Name patterns:

  • projects/{project}/policies/{policy}/tsConditions/{ts_condition}/regions/{region}/alerts/{alert}
  • projects/{project}/policies/{policy}/logConditions/{log_condition}/regions/{region}/alerts/{alert}

Parent resources:

This section covers the methods and messages to interact with Alert resource.

Alert Methods

Here is the list of Alert resource methods:

GetAlert Method

GetAlert

rpc GetAlert(GetAlertRequest) returns (Alert)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/alerts.get

The equivalent REST API is:

GET /v1/{name=projects/*/policies/*/tsConditions/*/regions/*/alerts/*} 
GET /v1/{name=projects/*/policies/*/logConditions/*/regions/*/alerts/*} 

BatchGetAlerts Method

BatchGetAlerts

rpc BatchGetAlerts(BatchGetAlertsRequest) returns (BatchGetAlertsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/alerts.batchGet

The equivalent REST API is:

GET /v1/alerts:batchGet 

ListAlerts Method

ListAlerts

rpc ListAlerts(ListAlertsRequest) returns (ListAlertsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/alerts.list

The equivalent REST API is:

GET /v1/{parent=projects/*/policies/*/tsConditions/*/regions/*}/alerts 
GET /v1/{parent=projects/*/policies/*/logConditions/*/regions/*}/alerts 

WatchAlert Method

WatchAlert

rpc WatchAlert(WatchAlertRequest) returns (WatchAlertResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/alerts.watch

The equivalent REST API is:

POST /v1/{name=projects/*/policies/*/tsConditions/*/regions/*/alerts/*}:watch 
POST /v1/{name=projects/*/policies/*/logConditions/*/regions/*/alerts/*}:watch 

WatchAlerts Method

WatchAlerts

rpc WatchAlerts(WatchAlertsRequest) returns (WatchAlertsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/alerts.watch

The equivalent REST API is:

POST /v1/{parent=projects/*/policies/*/tsConditions/*/regions/*}/alerts:watch 
POST /v1/{parent=projects/*/policies/*/logConditions/*/regions/*}/alerts:watch 

CreateAlert Method

CreateAlert

rpc CreateAlert(CreateAlertRequest) returns (Alert)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/alerts.create

The equivalent REST API is:

POST /v1/{parent=projects/*/policies/*/tsConditions/*/regions/*}/alerts (BODY: alert)
POST /v1/{parent=projects/*/policies/*/logConditions/*/regions/*}/alerts 

UpdateAlert Method

UpdateAlert

rpc UpdateAlert(UpdateAlertRequest) returns (Alert)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/alerts.update

The equivalent REST API is:

PUT /v1/{alert.name=projects/*/policies/*/tsConditions/*/regions/*/alerts/*} (BODY: alert)
PUT /v1/{alert.name=projects/*/policies/*/logConditions/*/regions/*/alerts/*} 

DeleteAlert Method

DeleteAlert

rpc DeleteAlert(DeleteAlertRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/alerts.delete

The equivalent REST API is:

DELETE /v1/{name=projects/*/policies/*/tsConditions/*/regions/*/alerts/*} 
DELETE /v1/{name=projects/*/policies/*/logConditions/*/regions/*/alerts/*} 

BulkSaveAlerts Method

BulkSaveAlerts

rpc BulkSaveAlerts(BulkSaveAlertsRequest) returns (BulkSaveAlertsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/alerts.bulkSave

The equivalent REST API is:

POST /v1/alerts:bulkSaveAlerts 

BulkMarkAsNotified Method

BulkMarkAsNotified

rpc BulkMarkAsNotified(BulkMarkAsNotifiedRequest) returns (BulkMarkAsNotifiedResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/alerts.bulkMarkAsNotified

The equivalent REST API is:

POST /v1/alerts:bulkMarkAsNotified 

Alert Messages

Here is the list of Alert resource messages:

Alert Message

NameTypeDescription
namestring (name of Alert)Name of Alert When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-zA-Z0-9_.:-]{1,128}
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
display_namestringDisplay name informing about basic params (condition display name and alerting resource)
alerting_resourceOwnerReferenceAlerting resource points to the original resource which generated alert. This meta reference works like dynamic type (any service, any resource). TODO: We could use of “DynamicReference” message type. It can be similar to OwnerReference, except it works more like reference (uses EstablishReferences…). It can support most normal behaviors, like CASCADE DELETE/UNSET.
ts_infoAlert.TsInfoInforms about alert based on TimeSeries data.
log_infoAlert.LogInfoInforms about alert based on Log data.
stateAlert.StateState of alert
internalAlert.InternalInternal field.

Alert.TsInfo Message

TsInfo contains Alert data created based on TimeSeries data.

NameTypeDescription
typeAlert.TsInfo.TypeType of TimeSeries alert - based on ANOMALY or THRESHOLD.
anomaly_window_size.google.protobuf.DurationIf alert type is ANOMALY, then this field is populated and informs for what window size anomaly was detected.
common_keybytesBinary key describing common metric/resource labels
metric_typesrepeated stringList of metric types used in TsCondition
resource_typesrepeated stringList of resource types used in TsCondition
common_metric_labelsmap<string, string>Metric labels by which we grouped TimeSeries data.
common_resource_labelsmap<string, string>Resource labels by which we grouped TimeSeries data.
time_seriesrepeated Alert.TsInfo.TimeSeriesAll TimeSeries corresponding to each TsCondition.Spec.Query object, according to unique combination of group by fields: resource/metric labels.

Alert.LogInfo Message

LogInfo contains Alert data created based on Log data.

NameTypeDescription
common_keybytesBinary key describing common labels
log_typesrepeated stringList of log descriptor types specified in parent LogCondition
common_log_labelsmap<string, string>Log labels by which we grouped Logs data.
violating_logstringContent of violating log

Alert.State Message

State is responsible for managing lifecycle of Alert. Each Alert

NameTypeDescription
is_firingboolInforms if alert is still firing
start_time.google.protobuf.TimestampTime when alert was raised
end_time.google.protobuf.TimestampTime when alert was silenced, if no longer firing
notification_statusesrepeated Alert.State.NotificationInforms where notifications about alert state changes must be sent.
escalation_levelAlert.State.EscalationLevelInforms who is handling alert as of now.
ai_agent_handling_stateAlert.State.AiHandlingStateInforms current state of alert handling by AI Agent if escalation level is AI_AGENT. If alert is on operator side, it will contain last decision made by AI agent.
ai_agent_last_state_change_time.google.protobuf.TimestampInforms when was the last state change of ai_agent_handling_state field.
ai_agent_diagnosis_notesstringContains AI Agent troubleshooting notes. If agent SSHed to alerting resource, it will also contain history of shell for visibility purposes.
ai_remediation_argstringOptional remediation information from AI Agent. This field may be populated when field ai_agent_handling_state switches to AI_REMEDIATION_PROPOSED, if necessary. For example, if AI Agent wants to SSH and execute some commands, it will contain these commands.
ai_remediationPolicySpec.AIAgentHandling.RemediationRemediation type proposed by AI Agent to fix an alert. This field is populated when field ai_agent_handling_state switches to AI_REMEDIATION_PROPOSED. Informs what kind of remediation AI Agent wants to execute.
ai_conversationstringOptional AI conversation reference used for troubleshooting. Format: “projects/{project}/conversations/{conversation}”
operator_handling_stateAlert.State.OperatorHandlingStateInforms current state of alert handling by Operator if escalation level is OPERATOR. If alert is on AI_AGENT side, it will contain last decision made by operator.
operator_last_state_change_time.google.protobuf.TimestampInforms when was the last state change of operator_handling_state field.
operator_notesstringOptional operator notes.
lifecycle_completedboolAlert has ended and any needed notifications are processed

Alert.Internal Message

Internal data.

NameTypeDescription
alerting_locationPolicySpec.ProcessingLocation

Alert.TsInfo.TimeSeries Message

TimeSeries object matches single TsCondition.Spec.Query object in parent TsCondition. It contains TimeSeries data points at a time of violation, along with relevant information, like thresholds specified in TsEntry.

NameTypeDescription
query_namestringQuery name of the matching TsCondition.Spec.Query object
valuesrepeated doubleTimeSeries data values during violation start. They will be outside of lower/upper thresholds range for THRESHOLD type alerts.
anomaliesrepeated doubleCorresponding detected anomaly values (square errors). Populated for ANOMALY type of alerts. They will be larger than anomaly threshold for ANOMALY type of alerts.
upper_thresholdAlertingThresholdUpper threshold that was active during violation. Populated for THRESHOLD type of alerts.
lower_thresholdAlertingThresholdLower threshold that was active during violation. Populated for THRESHOLD type of alerts.
anomaly_thresholddoubleAnomaly threshold that was active during violation. Populated for ANOMALY type of alerts.
after_duration.google.protobuf.DurationInforms how long violation was active at the time of raising alert.

Alert.State.Notification Message

Notification informs about pending notifications that must be sent due to changes in Alert state.

NameTypeDescription
kindNotificationChannelSpec.EventKindKind informs what type of State has changed, and for which we need to send notifications.
pending_channelsrepeated string (reference to NotificationChannel)Informs about list of channels to where notification should be sent according to the corresponding kind.

GetAlertRequest Message

A request message of the GetAlert method.

NameTypeDescription
namestring (name of Alert)Name of ntt.alerting.v1.Alert
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetAlertsRequest Message

A request message of the BatchGetAlerts method.

NameTypeDescription
namesrepeated string (name of Alert)Names of Alerts
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetAlertsResponse Message

A response message of the BatchGetAlerts method.

NameTypeDescription
alertsrepeated Alertfound Alerts
missingrepeated string (name of Alert)list of not found Alerts

ListAlertsRequest Message

A request message of the ListAlerts method.

NameTypeDescription
parentstring (parent name of Alert)Parent name of ntt.alerting.v1.Alert
page_sizeint32Requested page size. Server may return fewer Alerts than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of Alert)A token identifying a page of results the server should return. Typically, this is the value of ListAlertsResponse.next_page_token.
order_bystring (orderBy of Alert)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of Alert)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListAlertsResponse Message

A response message of the ListAlerts method.

NameTypeDescription
alertsrepeated AlertThe list of Alerts
prev_page_tokenstring (cursor of Alert)A token to retrieve previous page of results. Pass this value in the ListAlertsRequest.page_token.
next_page_tokenstring (cursor of Alert)A token to retrieve next page of results. Pass this value in the ListAlertsRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total Alerts across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchAlertRequest Message

A request message of the WatchAlert method.

NameTypeDescription
namestring (name of Alert)Name of ntt.alerting.v1.Alert
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchAlertResponse Message

A response message of the WatchAlert method.

NameTypeDescription
changeAlertChange

WatchAlertsRequest Message

A request message of the WatchAlerts method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of Alert)Parent name of ntt.alerting.v1.Alert
page_sizeint32Requested page size. Server may return fewer Alerts than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of Alert)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of Alert)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of Alert)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to Alert that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to Alert that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchAlertsResponse Message

A response message of the WatchAlerts method.

NameTypeDescription
alert_changesrepeated AlertChangeChanges of Alerts
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All Alerts will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchAlertsResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (Alerts will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchAlertsResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of Alert)New token to retrieve previous page of results.
next_page_tokenstring (cursor of Alert)New token to retrieve next page of results.

CreateAlertRequest Message

A request message of the CreateAlert method.

NameTypeDescription
parentstring (parent name of Alert)Parent name of ntt.alerting.v1.Alert
alertAlertAlert resource body
response_maskCreateAlertRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

CreateAlertRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields.

UpdateAlertRequest Message

A request message of the UpdateAlert method.

NameTypeDescription
alertAlertAlert resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateAlertRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
allow_missingboolIf set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update
response_maskUpdateAlertRequest.ResponseMaskreduce message response size.

UpdateAlertRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateAlertConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateAlertRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteAlertRequest Message

A request message of the DeleteAlert method.

NameTypeDescription
namestring (name of Alert)Name of ntt.alerting.v1.Alert
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

BulkSaveAlertsRequest Message

A request message of the BulkSaveAlerts method.

NameTypeDescription
projectstring (name of Project)
alertsrepeated Alert
update_mask.google.protobuf.FieldMask

BulkSaveAlertsResponse Message

A response message of the BulkSaveAlerts method.

NameTypeDescription
alertsrepeated Alert

BulkMarkAsNotifiedRequest Message

NameTypeDescription
projectstring (name of Project)
alertsrepeated string (name of Alert)
channelsrepeated string (name of NotificationChannel)

BulkMarkAsNotifiedResponse Message

NameTypeDescription
nonenonenone

Alert Enumerations

Here is the list of Alert resource enumerations:

Alert.TsInfo.Type Enumeration

Type of TimeSeries based alert

NameDescription
UNDEFINED
ANOMALYANOMALY indicates that irregular data pattern was spotted in time series data (anomaly values crossed anomaly thresholds).
THRESHOLDTHRESHOLD indicates that time series values crossed specified thresholds (lower or upper threshold).

Alert.State.AiHandlingState Enumeration

AiHandlingState informs what is a handling state of an alert from AI agent point of view. It is active when escalation_level points to AI_AGENT.

NameDescription
AI_AGENT_NOT_INVOLVEDAI Agent is not involved in handling this alert.
AI_AWAITING_HANDLINGAlert is new and awaits handling by AI agent. This is always initial state for AI agent after firing. It can move to AI_ESCALATED_TO_OPERATOR, AI_IGNORE_AS_TEMPORARY, AI_ADJUST_CND_ENTRY, or AI_REMEDIATION_PROPOSED.
AI_ESCALATED_TO_OPERATORThis state is active is AI agent escalated alert to an operator, due to inability to solve it. This is terminal state after which handling is passed to OPERATOR, escalation_level changes.
AI_IGNORE_AS_TEMPORARYAI Agent informed that, while TimeSeries/Logs data indeed contain abnormal values, they are caused by transient and unharmful reason, and it should stop firing soon. This is false positive alert. This is semi-terminal state. It can move to AI_ESCALATED_TO_OPERATOR if alert persist despite being flagged as transient issue.
AI_ADJUST_CND_ENTRYAI Agent informed that this alert is a false positive, and TimeSeries/Logs violating entries in fact should not be classified as a violation. Switching alert to this state will cause corresponding TsEntry to adjust its thresholds, or retrain AI anomaly detection models. This is usually a terminal state, after which alert is silenced and TsEntry tries to assume violating data is normal. However, if thresholds cannot be updated, alert will switch to AI_ESCALATED_TO_OPERATOR.
AI_REMEDIATION_PROPOSEDAI Agent identified this is a genuine alert, but for which it is able to fix. Remediation is only proposed, and requires approval from OPERATOR. Note that this is unique situation, where field escalation_level in State object points to AI_AGENT, but OPERATOR is requires to provide an update. Alert is technically still being handled by AI Agent, but waiting for OPERATOR confirmation.
AI_REMEDIATION_APPROVEDThis state is followed by AI_REMEDIATION_PROPOSED after OPERATOR agrees to execute, or if automatic approval is enabled. AI Agent will then proceed to applying remediation. It will move to AI_REMEDIATION_APPLIED after remediation is applied.
AI_REMEDIATION_APPLIEDThis state indicates that remediation has been applied. If after some time issue persists, then it switches to AI_ESCALATED_TO_OPERATOR.

Alert.State.OperatorHandlingState Enumeration

AiHandlingState informs what is a handling state of an alert from OPERATOR point of view.

NameDescription
OP_NOT_INVOLVEDOperator is not involved in handling this alert.
OP_AWAITING_HANDLINGAlert waits for Operator to handle it. This is initial state when escalation level switches to OPERATOR. From here, it can switch to any of remaining states. It may be also switched back to AI Agent if operator will it.
OP_ACKNOWLEDGEDThis can be a first state of Alert after OP_AWAITING_HANDLING, if operator wants to acknowledge alert without informing about final decision.
OP_IGNORE_AS_TEMPORARYOperator informed that, while TimeSeries/Logs data indeed contain abnormal values, they are caused by transient and unharmful reason, and it should stop firing soon. This is false positive alert. This may be terminal state if alert stops firing soon. Otherwise, it will go back to OP_AWAITING_HANDLING.
OP_ADJUST_CND_ENTRYOperator informed that this alert is a false positive, and TimeSeries/Logs violating entries in fact should not be classified as a violation. Switching alert to this state will cause corresponding TsEntry to adjust its thresholds, or retrain AI anomaly detection models, whatever is relevant. This is usually a terminal state, after which alert is silenced and TsEntry tries to assume violating data is normal. However, if thresholds cannot be updated, alert will switch to OP_AWAITING_HANDLING automatically.
OP_REMEDIATION_APPLIEDThis state indicates that remediation has been applied. If after some time issue persists, then it switches to OP_AWAITING_HANDLING.

Alert.State.EscalationLevel Enumeration

EscalationLevel informs who is handling an alert.

NameDescription
NONENone is invalid state.
AI_AGENTAlert is handled by AI Agent now
OPERATORAlert is handled by OPERATOR now.

Document Resource

Document can be attached to Policy, TsCondition or LogCondition resources. They should contain documentation that can be relevant when diagnosing & resolving alerts. They are especially important for AI Agent handling.

Name patterns:

  • projects/{project}/documents/{document}

Parent resources:

This section covers the methods and messages to interact with Document resource.

Document Methods

Here is the list of Document resource methods:

GetDocument Method

GetDocument

rpc GetDocument(GetDocumentRequest) returns (Document)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/documents.get

The equivalent REST API is:

GET /v1/{name=projects/*/documents/*} 

BatchGetDocuments Method

BatchGetDocuments

rpc BatchGetDocuments(BatchGetDocumentsRequest) returns (BatchGetDocumentsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/documents.batchGet

The equivalent REST API is:

GET /v1/documents:batchGet 

ListDocuments Method

ListDocuments

rpc ListDocuments(ListDocumentsRequest) returns (ListDocumentsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/documents.list

The equivalent REST API is:

GET /v1/{parent=projects/*}/documents 

WatchDocument Method

WatchDocument

rpc WatchDocument(WatchDocumentRequest) returns (WatchDocumentResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/documents.watch

The equivalent REST API is:

POST /v1/{name=projects/*/documents/*}:watch 

WatchDocuments Method

WatchDocuments

rpc WatchDocuments(WatchDocumentsRequest) returns (WatchDocumentsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/documents.watch

The equivalent REST API is:

POST /v1/{parent=projects/*}/documents:watch 

CreateDocument Method

CreateDocument

rpc CreateDocument(CreateDocumentRequest) returns (Document)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/documents.create

The equivalent REST API is:

POST /v1/{parent=projects/*}/documents (BODY: document)

UpdateDocument Method

UpdateDocument

rpc UpdateDocument(UpdateDocumentRequest) returns (Document)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/documents.update

The equivalent REST API is:

PUT /v1/{document.name=projects/*/documents/*} (BODY: document)

DeleteDocument Method

DeleteDocument

rpc DeleteDocument(DeleteDocumentRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/documents.delete

The equivalent REST API is:

DELETE /v1/{name=projects/*/documents/*} 

SearchDocuments Method

SearchDocuments

rpc SearchDocuments(SearchDocumentsRequest) returns (SearchDocumentsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/documents.search

The equivalent REST API is:

GET /v1/{parent=projects/*}/documents:search 

Document Messages

Here is the list of Document resource messages:

Document Message

NameTypeDescription
namestring (name of Document)Name of Document When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9]
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
titlestringDocument title
contentstringDocumentation content for operators
mime_typestringdocumentation mime type. Only "text/markdown" is supported.

GetDocumentRequest Message

A request message of the GetDocument method.

NameTypeDescription
namestring (name of Document)Name of ntt.alerting.v1.Document
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetDocumentsRequest Message

A request message of the BatchGetDocuments method.

NameTypeDescription
namesrepeated string (name of Document)Names of Documents
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetDocumentsResponse Message

A response message of the BatchGetDocuments method.

NameTypeDescription
documentsrepeated Documentfound Documents
missingrepeated string (name of Document)list of not found Documents

ListDocumentsRequest Message

A request message of the ListDocuments method.

NameTypeDescription
parentstring (parent name of Document)Parent name of ntt.alerting.v1.Document
page_sizeint32Requested page size. Server may return fewer Documents than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of Document)A token identifying a page of results the server should return. Typically, this is the value of ListDocumentsResponse.next_page_token.
order_bystring (orderBy of Document)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of Document)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListDocumentsResponse Message

A response message of the ListDocuments method.

NameTypeDescription
documentsrepeated DocumentThe list of Documents
prev_page_tokenstring (cursor of Document)A token to retrieve previous page of results. Pass this value in the ListDocumentsRequest.page_token.
next_page_tokenstring (cursor of Document)A token to retrieve next page of results. Pass this value in the ListDocumentsRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total Documents across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchDocumentRequest Message

A request message of the WatchDocument method.

NameTypeDescription
namestring (name of Document)Name of ntt.alerting.v1.Document
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchDocumentResponse Message

A response message of the WatchDocument method.

NameTypeDescription
changeDocumentChange

WatchDocumentsRequest Message

A request message of the WatchDocuments method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of Document)Parent name of ntt.alerting.v1.Document
page_sizeint32Requested page size. Server may return fewer Documents than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of Document)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of Document)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of Document)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to Document that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to Document that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchDocumentsResponse Message

A response message of the WatchDocuments method.

NameTypeDescription
document_changesrepeated DocumentChangeChanges of Documents
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All Documents will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchDocumentsResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (Documents will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchDocumentsResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of Document)New token to retrieve previous page of results.
next_page_tokenstring (cursor of Document)New token to retrieve next page of results.

CreateDocumentRequest Message

A request message of the CreateDocument method.

NameTypeDescription
parentstring (parent name of Document)Parent name of ntt.alerting.v1.Document
documentDocumentDocument resource body
response_maskCreateDocumentRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

CreateDocumentRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields.

UpdateDocumentRequest Message

A request message of the UpdateDocument method.

NameTypeDescription
documentDocumentDocument resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateDocumentRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
allow_missingboolIf set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update
response_maskUpdateDocumentRequest.ResponseMaskreduce message response size.

UpdateDocumentRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateDocumentConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateDocumentRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteDocumentRequest Message

A request message of the DeleteDocument method.

NameTypeDescription
namestring (name of Document)Name of ntt.alerting.v1.Document
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

SearchDocumentsRequest Message

A request message of the SearchDocuments method.

NameTypeDescription
parentstring (parent name of Document)Parent name of ntt.alerting.v1.Document
page_sizeint32Requested page size. Server may return fewer Documents than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of Document)A token identifying a page of results the server should return. Typically, this is the value of SearchDocumentsResponse.next_page_token.
order_bystring (orderBy of Document)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of Document)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
phrasestringOptional search phrase used to further filter results.

SearchDocumentsResponse Message

A response message of the SearchDocuments method.

NameTypeDescription
documentsrepeated DocumentThe list of Documents
prev_page_tokenstring (cursor of Document)A token to retrieve previous page of results. Pass this value in the SearchDocumentsRequest.page_token.
next_page_tokenstring (cursor of Document)A token to retrieve next page of results. Pass this value in the SearchDocumentsRequest.page_token.
current_offsetint32Current offset from the first page (0 if no page tokens were given). Page index can be computed from offset and limit provided in a request
total_results_countint32Number of total Documents across all pages.

LogCondition Resource

LogCondition describes when Alert based on Logs data should be raised.

Name patterns:

  • projects/{project}/policies/{policy}/logConditions/{log_condition}

Parent resources:

This section covers the methods and messages to interact with LogCondition resource.

LogCondition Methods

Here is the list of LogCondition resource methods:

GetLogCondition Method

GetLogCondition

rpc GetLogCondition(GetLogConditionRequest) returns (LogCondition)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditions.get

The equivalent REST API is:

GET /v1/{name=projects/*/policies/*/logConditions/*} 

BatchGetLogConditions Method

BatchGetLogConditions

rpc BatchGetLogConditions(BatchGetLogConditionsRequest) returns (BatchGetLogConditionsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditions.batchGet

The equivalent REST API is:

GET /v1/logConditions:batchGet 

ListLogConditions Method

ListLogConditions

rpc ListLogConditions(ListLogConditionsRequest) returns (ListLogConditionsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditions.list

The equivalent REST API is:

GET /v1/{parent=projects/*/policies/*}/logConditions 

WatchLogCondition Method

WatchLogCondition

rpc WatchLogCondition(WatchLogConditionRequest) returns (WatchLogConditionResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditions.watch

The equivalent REST API is:

POST /v1/{name=projects/*/policies/*/logConditions/*}:watch 

WatchLogConditions Method

WatchLogConditions

rpc WatchLogConditions(WatchLogConditionsRequest) returns (WatchLogConditionsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditions.watch

The equivalent REST API is:

POST /v1/{parent=projects/*/policies/*}/logConditions:watch 

CreateLogCondition Method

CreateLogCondition

rpc CreateLogCondition(CreateLogConditionRequest) returns (LogCondition)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditions.create

The equivalent REST API is:

POST /v1/{parent=projects/*/policies/*}/logConditions (BODY: log_condition)

UpdateLogCondition Method

UpdateLogCondition

rpc UpdateLogCondition(UpdateLogConditionRequest) returns (LogCondition)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditions.update

The equivalent REST API is:

PUT /v1/{log_condition.name=projects/*/policies/*/logConditions/*} (BODY: log_condition)

DeleteLogCondition Method

DeleteLogCondition

rpc DeleteLogCondition(DeleteLogConditionRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditions.delete

The equivalent REST API is:

DELETE /v1/{name=projects/*/policies/*/logConditions/*} 

SearchLogConditions Method

SearchLogConditions

rpc SearchLogConditions(SearchLogConditionsRequest) returns (SearchLogConditionsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditions.search

The equivalent REST API is:

GET /v1/{parent=projects/*/policies/*}/logConditions:search 

LogCondition Messages

Here is the list of LogCondition resource messages:

LogCondition Message

NameTypeDescription
namestring (name of LogCondition)Name of LogCondition When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9]
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
display_namestringDisplay Name
descriptionstringLong description
supporting_docsrepeated string (reference to Document)List of documents useful for troubleshooting and fixing alerts triggered by this condition.
specLogCndSpecDefines what query is being monitored, and what content must trigger an Alert.
internalLogCondition.InternalInternal field.
template_sourceLogCondition.TemplateSourcetemplate source for current LogCondition

LogCondition.Internal Message

Internal data.

NameTypeDescription
alerting_locationPolicySpec.ProcessingLocationInforms if log condition is processed at the backend or on edge.

LogCondition.TemplateSource Message

TemplateSource describes where condition is coming from originally.

NameTypeDescription
templatestring (reference to LogConditionTemplate)Reference to template
updated_fields.google.protobuf.FieldMaskList of modified fields compared to the template. It is a mask of Spec object.

GetLogConditionRequest Message

A request message of the GetLogCondition method.

NameTypeDescription
namestring (name of LogCondition)Name of ntt.alerting.v1.LogCondition
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetLogConditionsRequest Message

A request message of the BatchGetLogConditions method.

NameTypeDescription
namesrepeated string (name of LogCondition)Names of LogConditions
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetLogConditionsResponse Message

A response message of the BatchGetLogConditions method.

NameTypeDescription
log_conditionsrepeated LogConditionfound LogConditions
missingrepeated string (name of LogCondition)list of not found LogConditions

ListLogConditionsRequest Message

A request message of the ListLogConditions method.

NameTypeDescription
parentstring (parent name of LogCondition)Parent name of ntt.alerting.v1.LogCondition
page_sizeint32Requested page size. Server may return fewer LogConditions than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of LogCondition)A token identifying a page of results the server should return. Typically, this is the value of ListLogConditionsResponse.next_page_token.
order_bystring (orderBy of LogCondition)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of LogCondition)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListLogConditionsResponse Message

A response message of the ListLogConditions method.

NameTypeDescription
log_conditionsrepeated LogConditionThe list of LogConditions
prev_page_tokenstring (cursor of LogCondition)A token to retrieve previous page of results. Pass this value in the ListLogConditionsRequest.page_token.
next_page_tokenstring (cursor of LogCondition)A token to retrieve next page of results. Pass this value in the ListLogConditionsRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total LogConditions across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchLogConditionRequest Message

A request message of the WatchLogCondition method.

NameTypeDescription
namestring (name of LogCondition)Name of ntt.alerting.v1.LogCondition
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchLogConditionResponse Message

A response message of the WatchLogCondition method.

NameTypeDescription
changeLogConditionChange

WatchLogConditionsRequest Message

A request message of the WatchLogConditions method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of LogCondition)Parent name of ntt.alerting.v1.LogCondition
page_sizeint32Requested page size. Server may return fewer LogConditions than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of LogCondition)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of LogCondition)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of LogCondition)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to LogCondition that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to LogCondition that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchLogConditionsResponse Message

A response message of the WatchLogConditions method.

NameTypeDescription
log_condition_changesrepeated LogConditionChangeChanges of LogConditions
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All LogConditions will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchLogConditionsResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (LogConditions will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchLogConditionsResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of LogCondition)New token to retrieve previous page of results.
next_page_tokenstring (cursor of LogCondition)New token to retrieve next page of results.

CreateLogConditionRequest Message

A request message of the CreateLogCondition method.

NameTypeDescription
parentstring (parent name of LogCondition)Parent name of ntt.alerting.v1.LogCondition
log_conditionLogConditionLogCondition resource body
response_maskCreateLogConditionRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

CreateLogConditionRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields.

UpdateLogConditionRequest Message

A request message of the UpdateLogCondition method.

NameTypeDescription
log_conditionLogConditionLogCondition resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateLogConditionRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
allow_missingboolIf set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update
response_maskUpdateLogConditionRequest.ResponseMaskreduce message response size.

UpdateLogConditionRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateLogConditionConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateLogConditionRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteLogConditionRequest Message

A request message of the DeleteLogCondition method.

NameTypeDescription
namestring (name of LogCondition)Name of ntt.alerting.v1.LogCondition
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

SearchLogConditionsRequest Message

A request message of the SearchLogConditions method.

NameTypeDescription
parentstring (parent name of LogCondition)Parent name of ntt.alerting.v1.LogCondition
page_sizeint32Requested page size. Server may return fewer LogConditions than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of LogCondition)A token identifying a page of results the server should return. Typically, this is the value of SearchLogConditionsResponse.next_page_token.
order_bystring (orderBy of LogCondition)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of LogCondition)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
phrasestringOptional search phrase used to further filter results.

SearchLogConditionsResponse Message

A response message of the SearchLogConditions method.

NameTypeDescription
log_conditionsrepeated LogConditionThe list of LogConditions
prev_page_tokenstring (cursor of LogCondition)A token to retrieve previous page of results. Pass this value in the SearchLogConditionsRequest.page_token.
next_page_tokenstring (cursor of LogCondition)A token to retrieve next page of results. Pass this value in the SearchLogConditionsRequest.page_token.
current_offsetint32Current offset from the first page (0 if no page tokens were given). Page index can be computed from offset and limit provided in a request
total_results_countint32Number of total LogConditions across all pages.

LogConditionTemplate Resource

LogConditionTemplate provides pre-defined templates for LogCondition resources. They may be public ones (available for all projects to be copied), but also can be private and available in selected projects only. They are always provided within Policy template.

Name patterns:

  • projects/{project}/policyTemplates/{policy_template}/logConditionTemplates/{log_condition_template}

Parent resources:

This section covers the methods and messages to interact with LogConditionTemplate resource.

LogConditionTemplate Methods

Here is the list of LogConditionTemplate resource methods:

GetLogConditionTemplate Method

GetLogConditionTemplate

rpc GetLogConditionTemplate(GetLogConditionTemplateRequest) returns (LogConditionTemplate)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditionTemplates.get

The equivalent REST API is:

GET /v1/{name=projects/*/policyTemplates/*/logConditionTemplates/*} 

BatchGetLogConditionTemplates Method

BatchGetLogConditionTemplates

rpc BatchGetLogConditionTemplates(BatchGetLogConditionTemplatesRequest) returns (BatchGetLogConditionTemplatesResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditionTemplates.batchGet

The equivalent REST API is:

GET /v1/logConditionTemplates:batchGet 

ListLogConditionTemplates Method

ListLogConditionTemplates

rpc ListLogConditionTemplates(ListLogConditionTemplatesRequest) returns (ListLogConditionTemplatesResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditionTemplates.list

The equivalent REST API is:

GET /v1/{parent=projects/*/policyTemplates/*}/logConditionTemplates 

WatchLogConditionTemplate Method

WatchLogConditionTemplate

rpc WatchLogConditionTemplate(WatchLogConditionTemplateRequest) returns (WatchLogConditionTemplateResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditionTemplates.watch

The equivalent REST API is:

POST /v1/{name=projects/*/policyTemplates/*/logConditionTemplates/*}:watch 

WatchLogConditionTemplates Method

WatchLogConditionTemplates

rpc WatchLogConditionTemplates(WatchLogConditionTemplatesRequest) returns (WatchLogConditionTemplatesResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditionTemplates.watch

The equivalent REST API is:

POST /v1/{parent=projects/*/policyTemplates/*}/logConditionTemplates:watch 

CreateLogConditionTemplate Method

CreateLogConditionTemplate

rpc CreateLogConditionTemplate(CreateLogConditionTemplateRequest) returns (LogConditionTemplate)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditionTemplates.create

The equivalent REST API is:

POST /v1/{parent=projects/*/policyTemplates/*}/logConditionTemplates (BODY: log_condition_template)

UpdateLogConditionTemplate Method

UpdateLogConditionTemplate

rpc UpdateLogConditionTemplate(UpdateLogConditionTemplateRequest) returns (LogConditionTemplate)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditionTemplates.update

The equivalent REST API is:

PUT /v1/{log_condition_template.name=projects/*/policyTemplates/*/logConditionTemplates/*} (BODY: log_condition_template)

DeleteLogConditionTemplate Method

DeleteLogConditionTemplate

rpc DeleteLogConditionTemplate(DeleteLogConditionTemplateRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditionTemplates.delete

The equivalent REST API is:

DELETE /v1/{name=projects/*/policyTemplates/*/logConditionTemplates/*} 

SearchLogConditionTemplates Method

SearchLogConditionTemplates

rpc SearchLogConditionTemplates(SearchLogConditionTemplatesRequest) returns (SearchLogConditionTemplatesResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/logConditionTemplates.search

The equivalent REST API is:

GET /v1/{parent=projects/*/policyTemplates/*}/logConditionTemplates:search 

LogConditionTemplate Messages

Here is the list of LogConditionTemplate resource messages:

LogConditionTemplate Message

NameTypeDescription
namestring (name of LogConditionTemplate)Name of LogConditionTemplate When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9]
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
display_namestringDisplay Name
descriptionstringLong description
supporting_docsrepeated string (reference to Document)List of supporting documents. Pointed documents must be copied if LogCondition is created in different project.
spec_templateLogCndSpecPre defined template for LogCondition.Spec.

GetLogConditionTemplateRequest Message

A request message of the GetLogConditionTemplate method.

NameTypeDescription
namestring (name of LogConditionTemplate)Name of ntt.alerting.v1.LogConditionTemplate
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetLogConditionTemplatesRequest Message

A request message of the BatchGetLogConditionTemplates method.

NameTypeDescription
namesrepeated string (name of LogConditionTemplate)Names of LogConditionTemplates
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetLogConditionTemplatesResponse Message

A response message of the BatchGetLogConditionTemplates method.

NameTypeDescription
log_condition_templatesrepeated LogConditionTemplatefound LogConditionTemplates
missingrepeated string (name of LogConditionTemplate)list of not found LogConditionTemplates

ListLogConditionTemplatesRequest Message

A request message of the ListLogConditionTemplates method.

NameTypeDescription
parentstring (parent name of LogConditionTemplate)Parent name of ntt.alerting.v1.LogConditionTemplate
page_sizeint32Requested page size. Server may return fewer LogConditionTemplates than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of LogConditionTemplate)A token identifying a page of results the server should return. Typically, this is the value of ListLogConditionTemplatesResponse.next_page_token.
order_bystring (orderBy of LogConditionTemplate)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of LogConditionTemplate)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListLogConditionTemplatesResponse Message

A response message of the ListLogConditionTemplates method.

NameTypeDescription
log_condition_templatesrepeated LogConditionTemplateThe list of LogConditionTemplates
prev_page_tokenstring (cursor of LogConditionTemplate)A token to retrieve previous page of results. Pass this value in the ListLogConditionTemplatesRequest.page_token.
next_page_tokenstring (cursor of LogConditionTemplate)A token to retrieve next page of results. Pass this value in the ListLogConditionTemplatesRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total LogConditionTemplates across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchLogConditionTemplateRequest Message

A request message of the WatchLogConditionTemplate method.

NameTypeDescription
namestring (name of LogConditionTemplate)Name of ntt.alerting.v1.LogConditionTemplate
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchLogConditionTemplateResponse Message

A response message of the WatchLogConditionTemplate method.

NameTypeDescription
changeLogConditionTemplateChange

WatchLogConditionTemplatesRequest Message

A request message of the WatchLogConditionTemplates method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of LogConditionTemplate)Parent name of ntt.alerting.v1.LogConditionTemplate
page_sizeint32Requested page size. Server may return fewer LogConditionTemplates than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of LogConditionTemplate)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of LogConditionTemplate)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of LogConditionTemplate)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to LogConditionTemplate that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to LogConditionTemplate that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchLogConditionTemplatesResponse Message

A response message of the WatchLogConditionTemplates method.

NameTypeDescription
log_condition_template_changesrepeated LogConditionTemplateChangeChanges of LogConditionTemplates
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All LogConditionTemplates will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchLogConditionTemplatesResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (LogConditionTemplates will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchLogConditionTemplatesResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of LogConditionTemplate)New token to retrieve previous page of results.
next_page_tokenstring (cursor of LogConditionTemplate)New token to retrieve next page of results.

CreateLogConditionTemplateRequest Message

A request message of the CreateLogConditionTemplate method.

NameTypeDescription
parentstring (parent name of LogConditionTemplate)Parent name of ntt.alerting.v1.LogConditionTemplate
log_condition_templateLogConditionTemplateLogConditionTemplate resource body
response_maskCreateLogConditionTemplateRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

CreateLogConditionTemplateRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields.

UpdateLogConditionTemplateRequest Message

A request message of the UpdateLogConditionTemplate method.

NameTypeDescription
log_condition_templateLogConditionTemplateLogConditionTemplate resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateLogConditionTemplateRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
allow_missingboolIf set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update
response_maskUpdateLogConditionTemplateRequest.ResponseMaskreduce message response size.

UpdateLogConditionTemplateRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateLogConditionTemplateConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateLogConditionTemplateRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteLogConditionTemplateRequest Message

A request message of the DeleteLogConditionTemplate method.

NameTypeDescription
namestring (name of LogConditionTemplate)Name of ntt.alerting.v1.LogConditionTemplate
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

SearchLogConditionTemplatesRequest Message

A request message of the SearchLogConditionTemplates method.

NameTypeDescription
parentstring (parent name of LogConditionTemplate)Parent name of ntt.alerting.v1.LogConditionTemplate
page_sizeint32Requested page size. Server may return fewer LogConditionTemplates than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of LogConditionTemplate)A token identifying a page of results the server should return. Typically, this is the value of SearchLogConditionTemplatesResponse.next_page_token.
order_bystring (orderBy of LogConditionTemplate)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of LogConditionTemplate)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
phrasestringOptional search phrase used to further filter results.

SearchLogConditionTemplatesResponse Message

A response message of the SearchLogConditionTemplates method.

NameTypeDescription
log_condition_templatesrepeated LogConditionTemplateThe list of LogConditionTemplates
prev_page_tokenstring (cursor of LogConditionTemplate)A token to retrieve previous page of results. Pass this value in the SearchLogConditionTemplatesRequest.page_token.
next_page_tokenstring (cursor of LogConditionTemplate)A token to retrieve next page of results. Pass this value in the SearchLogConditionTemplatesRequest.page_token.
current_offsetint32Current offset from the first page (0 if no page tokens were given). Page index can be computed from offset and limit provided in a request
total_results_countint32Number of total LogConditionTemplates across all pages.

NotificationChannel Resource

NotificationChannel specifies channel where notifications about alert updates can be sent.

Name patterns:

  • projects/{project}/notificationChannels/{notification_channel}

Parent resources:

This section covers the methods and messages to interact with NotificationChannel resource.

NotificationChannel Methods

Here is the list of NotificationChannel resource methods:

GetNotificationChannel Method

GetNotificationChannel

rpc GetNotificationChannel(GetNotificationChannelRequest) returns (NotificationChannel)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/notificationChannels.get

The equivalent REST API is:

GET /v1/{name=projects/*/notificationChannels/*} 

BatchGetNotificationChannels Method

BatchGetNotificationChannels

rpc BatchGetNotificationChannels(BatchGetNotificationChannelsRequest) returns (BatchGetNotificationChannelsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/notificationChannels.batchGet

The equivalent REST API is:

GET /v1/notificationChannels:batchGet 

ListNotificationChannels Method

ListNotificationChannels

rpc ListNotificationChannels(ListNotificationChannelsRequest) returns (ListNotificationChannelsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/notificationChannels.list

The equivalent REST API is:

GET /v1/{parent=projects/*}/notificationChannels 

WatchNotificationChannel Method

WatchNotificationChannel

rpc WatchNotificationChannel(WatchNotificationChannelRequest) returns (WatchNotificationChannelResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/notificationChannels.watch

The equivalent REST API is:

POST /v1/{name=projects/*/notificationChannels/*}:watch 

WatchNotificationChannels Method

WatchNotificationChannels

rpc WatchNotificationChannels(WatchNotificationChannelsRequest) returns (WatchNotificationChannelsResponse)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/notificationChannels.watch

The equivalent REST API is:

POST /v1/{parent=projects/*}/notificationChannels:watch 

CreateNotificationChannel Method

CreateNotificationChannel

rpc CreateNotificationChannel(CreateNotificationChannelRequest) returns (NotificationChannel)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/notificationChannels.create

The equivalent REST API is:

POST /v1/{parent=projects/*}/notificationChannels (BODY: notification_channel)

UpdateNotificationChannel Method

UpdateNotificationChannel

rpc UpdateNotificationChannel(UpdateNotificationChannelRequest) returns (NotificationChannel)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/notificationChannels.update

The equivalent REST API is:

PUT /v1/{notification_channel.name=projects/*/notificationChannels/*} (BODY: notification_channel)

DeleteNotificationChannel Method

DeleteNotificationChannel

rpc DeleteNotificationChannel(DeleteNotificationChannelRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/notificationChannels.delete

The equivalent REST API is:

DELETE /v1/{name=projects/*/notificationChannels/*} 

TestNotificationChannel Method

TestNotificationChannel

rpc TestNotificationChannel(TestNotificationChannelRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/alerting.edgelq.com/permissions/notificationChannels.test

The equivalent REST API is:

POST /v1/{name=projects/*/notificationChannels/*}:test 

NotificationChannel Messages

Here is the list of NotificationChannel resource messages:

NotificationChannel Message

NameTypeDescription
namestring (name of NotificationChannel)Name of NotificationChannel When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9]
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
display_namestringDisplay Name
descriptionstringdescription
specNotificationChannelSpecSpecification
stateNotificationChannel.StateState

NotificationChannel.State Message

State of NotificationChannel

NameTypeDescription
statusNotificationChannel.State.StatusStatus
errorNotificationChannel.State.ErrorError

NotificationChannel.State.Error Message

Error of NotificationChannel

NameTypeDescription
time.google.protobuf.Timestamp
messagestring

GetNotificationChannelRequest Message

A request message of the GetNotificationChannel method.

NameTypeDescription
namestring (name of NotificationChannel)Name of ntt.alerting.v1.NotificationChannel
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetNotificationChannelsRequest Message

A request message of the BatchGetNotificationChannels method.

NameTypeDescription
namesrepeated string (name of NotificationChannel)Names of NotificationChannels
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetNotificationChannelsResponse Message

A response message of the BatchGetNotificationChannels method.

NameTypeDescription
notification_channelsrepeated NotificationChannelfound NotificationChannels
missingrepeated string (name of NotificationChannel)list of not found NotificationChannels

ListNotificationChannelsRequest Message

A request message of the ListNotificationChannels method.

NameTypeDescription
parentstring (parent name of NotificationChannel)Parent name of ntt.alerting.v1.NotificationChannel
page_sizeint32Requested page size. Server may return fewer NotificationChannels than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of NotificationChannel)A token identifying a page of results the server should return. Typically, this is the value of ListNotificationChannelsResponse.next_page_token.
order_bystring (orderBy of NotificationChannel)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of NotificationChannel)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListNotificationChannelsResponse Message

A response message of the ListNotificationChannels method.

NameTypeDescription
notification_channelsrepeated NotificationChannelThe list of NotificationChannels
prev_page_tokenstring (cursor of NotificationChannel)A token to retrieve previous page of results. Pass this value in the ListNotificationChannelsRequest.page_token.
next_page_tokenstring (cursor of NotificationChannel)A token to retrieve next page of results. Pass this value in the ListNotificationChannelsRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total NotificationChannels across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchNotificationChannelRequest Message

A request message of the WatchNotificationChannel method.

NameTypeDescription
namestring (name of NotificationChannel)Name of ntt.alerting.v1.NotificationChannel
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchNotificationChannelResponse Message

A response message of the WatchNotificationChannel method.

NameTypeDescription
changeNotificationChannelChange

WatchNotificationChannelsRequest Message

A request message of the WatchNotificationChannels method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of NotificationChannel)Parent name of ntt.alerting.v1.NotificationChannel
page_sizeint32Requested page size. Server may return fewer NotificationChannels than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of NotificationChannel)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of NotificationChannel)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of NotificationChannel)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to NotificationChannel that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to NotificationChannel that don’t affect any of masked fields won’t be sent back.
[...]
